import os
import socket
import xmlrpclib
from ssl import SSLError
import keyring
from sixfeetup.todo.ticket import Ticket


class ToDo(object):
    """An object that represents the users list
    """

    def __init__(self, component=""):
        """
        """
        self.component = component
        self.server = None
        self.tickets = []
        self.query_string = (
            "status!=closed&owner=%(username)s&component=%(component)s")

    def initialize_server(self):
        server_string = (
            "https://%s:%s@trac.sixfeetup.com/operations/login/xmlrpc")
        self.server = xmlrpclib.ServerProxy(
            server_string % (self.username, self.password))
        # you've got five seconds to complete a task, come on Trac!
        socket.setdefaulttimeout(5)

    def user_credentials(self, username=None):
        """
        """
        if username is None:
            username = os.getlogin()
        self.username = username
        self.password = keyring.get_password('todo', username)

    def get_tickets(self):
        query_options = dict(username=self.username, component=self.component)
        ticket_ids = self.server.ticket.query(
            self.query_string % query_options)
        for ticket_id in ticket_ids:
            # for some reason, some tickets are impossible to retrieve
            # but this is completely random?!?
            try:
                ticket = self.server.ticket.get(ticket_id)
            except SSLError:
                error_msg = "couldn't retrieve #%s" % ticket_id
                ticket_obj = Ticket(
                    ticket_id, error_msg, "!ERROR - timed out", "???", "none")
                self.tickets.append(ticket_obj)
            ticket_dict = ticket[3]
            milestone = ticket_dict['milestone']
            summary = ticket_dict['summary']
            flag = ticket_dict['flag']
            priority = ticket_dict['priority']
            ticket_obj = Ticket(ticket_id, summary, milestone, priority, flag)
            self.tickets.append(ticket_obj)
        # let's sort them once we are done
        self.tickets.sort()

    def show_list(self):
        """This is kind of fugly at the moment, could use a little love
        """
        milestone = ""
        for ticket in self.tickets:
            if milestone != ticket.milestone:
                print
                print ticket.milestone
                print
            milestone = ticket.milestone
            priority = ticket.priority
            flag = ticket.flag
            if str(flag).lower() == "none":
                flag = ""
            else:
                flag = "(%s)" % flag
            summary = ticket.summary
            print "%(priority)s%(flag)s: %(summary)s" % locals()
